using UnityEngine;
using System.Collections;

public class camelScript : MonoBehaviour
{
	private NavMeshAgent m_NavMeshAgent;
	private CharacterController m_CharacterController;
	private Vector3 m_StartPosition;
	private Quaternion m_StartRotation;
	private Phase m_Phase;
	private mummyScript m_ParentScript;
	
	enum ControllState
	{
		MOTOR,
		MANUAL,
	};
	
	enum Phase
	{
		NONE,
		PHASE_1,
		PHASE_2,
		PHASE_3,
		PHASE_4,
		PHASE_5,
	}
	
	// Use this for initialization
	void Start ()
	{
		this.animation.Play("walk");
		this.animation["walk"].speed = 1.2f;
		this.animation.wrapMode = WrapMode.Once;
		
		this.m_NavMeshAgent = this.GetComponent(typeof(NavMeshAgent)) as NavMeshAgent;
		this.m_CharacterController = this.GetComponent(typeof(CharacterController)) as CharacterController;
		this.m_NavMeshAgent.enabled = false;
		this.m_CharacterController.enabled = false;
		this.m_Phase = Phase.NONE;
		this.m_StartPosition = this.transform.position;
		this.m_StartRotation = this.transform.rotation;
	}
	
	public void setParent(mummyScript parent)
	{
		this.m_ParentScript = parent;
	}
	
	public void goToCharacter()
	{
		this.m_NavMeshAgent.enabled = true;
		this.m_CharacterController.enabled = true;
		//this.m_NavMeshAgent.destination = new Vector3(-4.312558f, -0.6996235f, 2.249545f);
//		this.m_NavMeshAgent.destination = new Vector3(1.941919f, -6.473111f, -2.822185f);
		this.m_NavMeshAgent.destination = new Vector3(-2.42962f, -1.819668f, 2.249545f);
		this.m_Phase = Phase.PHASE_1;
	}
	
	public void goHome()
	{
		Debug.Log("start go home");
		StartCoroutine(goHomeStart());
	}
	
	private IEnumerator goHomeStart()
	{
		this.animation.CrossFade("stand");
		yield return new WaitForSeconds(0.5f);
		this.m_Phase = Phase.PHASE_4;
	}
	
	// Update is called once per frame
	void Update ()
	{
		if (this.m_NavMeshAgent.remainingDistance > 0.1f && !float.IsInfinity(this.m_NavMeshAgent.remainingDistance))
		{
			if (!this.animation.IsPlaying("walk"))
				this.animation.Play("walk");
		}
		else 
		{
			if (this.m_Phase == Phase.PHASE_1)
			{
				this.m_Phase = Phase.PHASE_2;
				this.m_NavMeshAgent.enabled = false;
				this.m_CharacterController.enabled = false;
				this.animation.CrossFade("sit");
			}
			else if (this.m_Phase == Phase.PHASE_2 && !this.animation.IsPlaying("sit"))
			{
				this.m_ParentScript.drink();
				this.m_Phase = Phase.PHASE_3;
			}
			else if (this.m_Phase == Phase.PHASE_4 && !this.animation.IsPlaying("stand"))
			{
				this.m_Phase = Phase.PHASE_5;
				this.m_NavMeshAgent.enabled = true;
				this.m_CharacterController.enabled = true;
				this.m_NavMeshAgent.destination = new Vector3(-this.m_StartPosition.x, this.m_StartPosition.y, this.m_StartPosition.z);
				this.animation.CrossFade("walk");
			}
			else if (this.m_Phase == Phase.PHASE_5)
			{
				this.m_NavMeshAgent.enabled = false;
				this.m_CharacterController.enabled = false;
				this.m_Phase = Phase.NONE;
				this.animation.Stop();
				this.transform.position = this.m_StartPosition;
				this.transform.rotation = this.m_StartRotation;
			}
			else if (this.m_Phase == Phase.NONE)
			{
				this.animation.Stop();
			}
		}
	}
}

