using UnityEngine;
using System.Collections;

public class cowboyScript : CigObjectInterface {
	public GameObject m_gameObject;
	public horseScript m_HorseScript;
	public Transform m_HorseSeatTransform;
	public Vector3 m_HorseOffset;
	private Transform oldParent;
	private Vector3 initPosition;
	private Quaternion initRotation;
	private bool showGUI;
	public AudioSource m_cowboyAudioSource;
	public AudioClip m_WhistlingClip;
	public AudioClip m_SmookingClip;
	public AudioClip m_CigaretesDestroyClip;
	public AudioClip m_JumpOffClip;
	public AudioClip m_JumpOnClip;
	public AudioClip m_StartSmookingClip;
	public AudioClip m_GetOnTheHorseClip;
	public GameObject m_Cigaretes;
	public GameObject m_Lighter;
	public ParticleSystem m_CigaretePS;
	public ParticleSystem m_MountSmokePS;
	public ParticleSystem m_LighterPS;
	private bool firstStart = true;

	// Use this for initialization
	void Start () {
		this.showGUI = true;
		this.m_gameObject.animation.wrapMode = WrapMode.Loop;
		this.oldParent = this.m_gameObject.transform.parent;
		this.initPosition = this.m_gameObject.transform.position;
		this.initRotation = this.m_gameObject.transform.rotation;
		
		this.m_Cigaretes.renderer.enabled = false;
		this.m_Lighter.renderer.enabled = false;
		
		this.m_CigaretePS.enableEmission = false;
		this.m_MountSmokePS.enableEmission = false;
		this.m_LighterPS.enableEmission = false;
	}
	
	
	public override void init()
	{
		if (this.firstStart)
		{
			this.m_gameObject.animation.Rewind();
			this.m_gameObject.animation.Play("Smooking");
			this.m_gameObject.animation.wrapMode = WrapMode.Loop;
			this.m_cowboyAudioSource.clip = this.m_SmookingClip;
			this.m_cowboyAudioSource.loop = true;
			this.m_cowboyAudioSource.Play();
			this.firstStart = false;
			
			this.m_Cigaretes.renderer.enabled = true;
			this.m_Lighter.renderer.enabled = false;
			
			this.m_CigaretePS.enableEmission = true;
			this.m_MountSmokePS.enableEmission = true;
			this.m_LighterPS.enableEmission = false;
		}
	}
	
	public override void lose()
	{
		
	}
	
	public override void restart()
	{
		this.showGUI = true;
		this.firstStart = true;
		this.m_gameObject.animation.wrapMode = WrapMode.Loop;
		this.m_gameObject.transform.parent = this.oldParent;
		this.m_gameObject.transform.position = this.initPosition;
		this.m_gameObject.transform.rotation = this.initRotation;
		
		this.m_cowboyAudioSource.Stop();
		/*
		this.m_gameObject.animation.Rewind();
		this.m_gameObject.animation.Play("Smooking");
		this.m_gameObject.animation.wrapMode = WrapMode.Loop;
		
		this.m_cowboyAudioSource.clip = this.m_SmookingClip;
		this.m_cowboyAudioSource.loop = true;
		this.m_cowboyAudioSource.Play();
		*/
		
		this.m_Cigaretes.renderer.enabled = false;
		this.m_Lighter.renderer.enabled = false;
		
		this.m_CigaretePS.enableEmission = false;
		this.m_MountSmokePS.enableEmission = false;
		this.m_LighterPS.enableEmission = false;
		
		this.m_HorseScript.restart();
	}
	
	public override void SmokeOn()
	{
		this.showGUI = false;
		this.m_HorseScript.goHomeAgain();
	}
	
	public override void SmokeOff()
	{
		this.showGUI = false;
		this.startOnAnimation();
	}
	
	public override bool ShowGUI()
	{
		return this.showGUI;
	}

	private IEnumerator stopSmooking()
	{
		this.m_HorseScript.restart();
		
		this.m_cowboyAudioSource.Stop();
		this.m_gameObject.animation.CrossFade("Stop Smooking");
		this.m_MountSmokePS.enableEmission = false;

		//yield return new WaitForSeconds(0.0f);
		this.m_cowboyAudioSource.clip = this.m_CigaretesDestroyClip;
		this.m_cowboyAudioSource.loop = false;
		this.m_cowboyAudioSource.Play();
		
		this.m_gameObject.animation.wrapMode = WrapMode.Once;
		this.m_gameObject.animation.PlayQueued("Jump off the package", QueueMode.CompleteOthers);
		
		yield return new WaitForSeconds(1.4f);
		this.m_Cigaretes.renderer.enabled = false;
		this.m_CigaretePS.enableEmission = false;
		
		yield return new WaitForSeconds(0.5f);
		this.m_cowboyAudioSource.clip = this.m_JumpOffClip;
		this.m_cowboyAudioSource.loop = false;
		this.m_cowboyAudioSource.Play();
		
		
		this.m_gameObject.animation.PlayQueued("whitling", QueueMode.CompleteOthers);
		yield return new WaitForSeconds(1.9f);
		this.m_cowboyAudioSource.clip = this.m_WhistlingClip;
		this.m_cowboyAudioSource.loop = false;
		this.m_cowboyAudioSource.Play();
		//this.m_gameObject.animation.PlayQueued("stay", QueueMode.CompleteOthers);
		yield return new WaitForSeconds(2.2f);
	
		this.m_gameObject.animation.wrapMode = WrapMode.Loop;
		this.m_gameObject.animation.CrossFade("stay");
		
		this.m_HorseScript.goHomeHorse();
		//this.m_gameObject.animation.PlayQueued("get on the horse", QueueMode.CompleteOthers);
		//this.m_gameObject.animation.PlayQueued("riding", QueueMode.CompleteOthers);
		yield return new WaitForSeconds(0.0f);
	}
	
	public IEnumerator horseIsReadyCallback()
	{
		//Debug.Log("horseIsReadyCallback()");
		this.m_gameObject.animation["get on the horse"].speed = 1.0f;
		this.m_gameObject.animation.CrossFade("get on the horse");
		this.m_gameObject.animation.wrapMode = WrapMode.Once;

		this.m_cowboyAudioSource.clip = this.m_GetOnTheHorseClip;
		this.m_cowboyAudioSource.loop = false;
		this.m_cowboyAudioSource.Play();
		
		yield return new WaitForSeconds(1.5f);
		this.m_gameObject.animation.CrossFade("riding");
		this.m_gameObject.animation.wrapMode = WrapMode.Loop;
		this.OnHorse();
		
		yield return new WaitForSeconds(0.5f);
		this.showGUI = true;
	}
	
	public void OnBackLegs()
	{
		this.m_gameObject.animation.CrossFade("on the back legs");
		this.m_gameObject.animation.wrapMode = WrapMode.Once;
	}
	
	public void Riding()
	{
		this.m_gameObject.animation.PlayQueued("riding");
		this.m_gameObject.animation.wrapMode = WrapMode.Loop;
	}
	
	private void OnHorse()
	{
		this.m_gameObject.transform.parent = this.m_HorseSeatTransform;
		this.m_HorseScript.runHorse();
	}
	
	private void startOnAnimation()
	{
		StartCoroutine(stopSmooking());
	}
	
	private static Quaternion Inverse(Quaternion quaternion)
	{
		Quaternion quaternion2;
		float num2 = (((quaternion.x * quaternion.x) + (quaternion.y * quaternion.y)) + (quaternion.z * quaternion.z)) + (quaternion.w * quaternion.w);
		float num = 1.0f / num2;
		quaternion2.x = -quaternion.x * num;
		quaternion2.y = -quaternion.y * num;
		quaternion2.z = -quaternion.z * num;
		quaternion2.w = quaternion.w * num;
		
		return quaternion2;
	}
	
	public IEnumerator startOffAnimation()
	{
		this.m_gameObject.transform.position = this.initPosition;
		this.m_gameObject.transform.rotation = this.initRotation;
		this.m_gameObject.transform.parent = this.oldParent;
		this.m_gameObject.animation.wrapMode = WrapMode.Once;
		this.m_gameObject.animation["get on the horse"].wrapMode = WrapMode.PingPong;
		this.m_gameObject.animation["get on the horse"].time = this.m_gameObject.animation["get on the horse"].length;
		this.m_gameObject.animation.CrossFade("get on the horse");
		
		yield return new WaitForSeconds(1.1f);
		this.m_gameObject.animation["get on the horse"].wrapMode = WrapMode.Once;
		this.m_gameObject.animation["get on the horse"].time = 0.0f;
		this.m_gameObject.animation.CrossFade("jump on the package");

		
		yield return new WaitForSeconds(0.5f);
		this.m_gameObject.animation["get on the horse"].wrapMode = WrapMode.Once;
		this.m_cowboyAudioSource.clip = this.m_JumpOnClip;
		this.m_cowboyAudioSource.loop = false;
		this.m_cowboyAudioSource.Play();
		
		this.m_gameObject.animation.PlayQueued("start smooking");

		yield return new WaitForSeconds(0.3f);
		this.m_HorseScript.goToTheHell();
		
		yield return new WaitForSeconds(4.0f);
		this.m_gameObject.animation["get on the horse"].wrapMode = WrapMode.Once;
		this.m_Cigaretes.renderer.enabled = true;
		this.m_Lighter.renderer.enabled = true;
	
		yield return new WaitForSeconds(0.4f);
		this.m_cowboyAudioSource.clip = this.m_StartSmookingClip;
		this.m_cowboyAudioSource.loop = false;
		this.m_cowboyAudioSource.Play();
		this.m_CigaretePS.enableEmission = true;

		this.m_gameObject.animation.PlayQueued("Smooking", QueueMode.CompleteOthers);

		yield return new WaitForSeconds(0.1f);
		this.m_LighterPS.enableEmission = true;
		
		yield return new WaitForSeconds(0.7f);
		this.m_LighterPS.enableEmission = false;
		
		yield return new WaitForSeconds(0.9f);
		this.m_Lighter.renderer.enabled = false;
		
		yield return new WaitForSeconds(0.1f);
		this.m_cowboyAudioSource.clip = this.m_SmookingClip;
		this.m_cowboyAudioSource.loop = true;
		this.m_cowboyAudioSource.Play();
		
		yield return new WaitForSeconds(2.0f);
		this.m_MountSmokePS.enableEmission = true;
		this.m_gameObject.animation.wrapMode = WrapMode.Loop;
		this.showGUI = true;
		//this.m_HorseScript.goHomeHorse();
	}
	
	void Update () {
	
	}
}
