using UnityEngine;
using System.Collections;

public class guiScript : MonoBehaviour {
	public Texture2D m_smokeIconOn;
	public Texture2D m_smokeIconOff;
	private Texture2D m_smokeIcon;
	public CigObjectInterface m_cowboyScript;
	public Texture2D m_splashScreenBackground;
	public Texture2D m_splashScreenLogo;
	public Texture2D m_splashScreenInfo;
	private bool showSplashscreen;
	private bool startApp;
	public CigObjectInterface[] m_allCowboysScript;
	
	// Use this for initialization
	void Start () {
		this.m_smokeIcon = this.m_smokeIconOff;
		this.showSplashscreen = true;
		this.startApp = true;
		
	}
	
	void OnGUI()
	{
		if (this.startApp)
		{
			StartCoroutine(this.ShowSplashScreen());
			this.startApp = false;
		}
		
		if (this.m_cowboyScript != null && this.m_cowboyScript.ShowGUI())
		{
			float rate = Mathf.Min(Screen.height, Screen.width) / 960.0f;
			float size = 150.0f * rate;
			float padding = 50.0f * rate;
			if (GUI.Button(new Rect(Screen.width - padding - size, padding, size, size), m_smokeIcon, GUIStyle.none))
			{
				if (this.isOn())
				{
					this.m_smokeIcon = this.m_smokeIconOff;
					this.m_cowboyScript.SmokeOn();
				}
				else
				{
					this.m_smokeIcon = this.m_smokeIconOn;
					this.m_cowboyScript.SmokeOff();
				}
			}
		}
		
		if (this.showSplashscreen)
		{
			float percentInfo = 0.8f;
			float percentLogo = 0.2f;
			
			if (Screen.height > Screen.width)
			{
				percentLogo = 0.1f;
				percentInfo = 0.4f;
			}
			
			GUI.DrawTexture(new Rect(0, 0, Screen.width, Screen.height), this.m_splashScreenBackground);
			float rate = 1185.0f / 934.0f;
			float width = Screen.height * percentInfo * rate;
			float height = Screen.height * percentInfo;
			GUI.DrawTexture(new Rect((Screen.width - width) * 0.5f, (Screen.height - height) * 0.5f, width, height), this.m_splashScreenInfo);
			rate = 297.0f / 297.0f;
			width = Screen.height * percentLogo * rate;
			height = Screen.height * percentLogo;
			GUI.DrawTexture(new Rect(Screen.width - width, 0, width, height), this.m_splashScreenLogo);
		}
	}
	
	private IEnumerator ShowSplashScreen()
	{
		yield return new WaitForSeconds(4.0f);
		this.showSplashscreen = false;
	}
	
	public void restart()
	{
		this.m_smokeIcon = this.m_smokeIconOff;
		
		for (int i = 0; i < this.m_allCowboysScript.Length; i++)
		{
			if (this.m_allCowboysScript[i] != null)
				this.m_allCowboysScript[i].restart();
		}
	}
	
	private bool isOn()
	{
		return this.m_smokeIcon == this.m_smokeIconOn;
	}
	
	// Update is called once per frame
	void Update () {
	}
}
