using UnityEngine;
using System.Collections;

public class mummyScript : CigObjectInterface {
	public GameObject m_gameObject;
	public GameObject m_sarcophageObject;
	public camelScript m_CamelScript;
	public Transform m_Vase;
	public Transform m_CamelSeatTransform;
	public Transform m_MummyHand;
	private Vector3 m_VaseOriginalPosition;
	private Quaternion m_VaseOriginalRotation;
	public Vector3 m_CamelOffset;
	private Transform oldParent;
	private Vector3 initPosition;
	private Quaternion initRotation;
	private bool showGUI;
	public AudioSource m_mummyAudioSource;
	public AudioSource m_cameraAudioSource;
	public ParticleSystem m_LeftSmokePS;
	public ParticleSystem m_RightSmokePS;
	private bool firstStart = true;
	private Transform m_VaseOriginalParent;
	public AudioClip m_dance;
	public AudioClip m_openSarcophage;
	public AudioClip m_magic;
	public AudioClip m_drinking;
	public AudioClip m_cracking_the_back;
	public AudioClip m_puttingDownCigaretes;
	public AudioClip m_smoke;
	public AudioClip m_jumpOff;
	public AudioClip m_jumpOn;
	public AudioClip m_StartSmooke;

	void Start () 
	{
		this.showGUI = true;
		
		this.oldParent = this.m_gameObject.transform.parent;
		this.initPosition = this.m_gameObject.transform.position;
		this.initRotation = this.m_gameObject.transform.rotation;
		
		this.m_VaseOriginalParent = this.m_Vase.parent;
		
		this.m_LeftSmokePS.enableEmission = false;
		this.m_RightSmokePS.enableEmission = false;
		
		this.m_CamelScript.setParent(this);
	}
	
	public override void init()
	{
		if (this.firstStart)
		{
			this.m_gameObject.animation["stay"].speed = 0.0f;
			this.m_gameObject.animation.Play("stay", AnimationPlayMode.Stop);
			this.m_gameObject.animation.wrapMode = WrapMode.Once;

			this.firstStart = false;
			
			this.m_mummyAudioSource.loop = false;
			
			this.m_cameraAudioSource.clip = this.m_smoke;
			this.m_cameraAudioSource.loop = true;
			this.m_cameraAudioSource.Play();
			
			this.m_LeftSmokePS.enableEmission = true;
			this.m_RightSmokePS.enableEmission = true;
			
		}		
	}
	
	private void startOnAnimation()
	{
		StartCoroutine(stopSmooking());
	}

	private void startSmookAnimation()
	{
		StartCoroutine(startSmooking());
	}
	
	private IEnumerator stopSmooking()
	{
		this.m_cameraAudioSource.clip = this.m_puttingDownCigaretes;
		this.m_cameraAudioSource.loop = false;
		this.m_cameraAudioSource.Play();
		
		this.m_LeftSmokePS.enableEmission = false;
		this.m_RightSmokePS.enableEmission = false;
		yield return new WaitForSeconds(3.0f);
		this.m_sarcophageObject.animation.Play("open");
		this.m_mummyAudioSource.clip = this.m_openSarcophage;
		this.m_mummyAudioSource.loop = false;
		this.m_mummyAudioSource.Play();
		yield return new WaitForSeconds(1.7f);
		this.m_gameObject.animation["stay"].speed = 1.0f;
		this.m_gameObject.animation.Play();
		this.m_gameObject.animation.CrossFadeQueued("jump_off_the_package");
		this.m_gameObject.animation.CrossFadeQueued("stretch_the_back");
		this.m_gameObject.animation.CrossFadeQueued("magic");
		yield return new WaitForSeconds(0.5f);
		this.m_mummyAudioSource.clip = this.m_jumpOff;
		this.m_mummyAudioSource.loop = false;
		this.m_mummyAudioSource.Play();
		yield return new WaitForSeconds(1.5f);
		this.m_cameraAudioSource.clip = this.m_cracking_the_back;
		this.m_cameraAudioSource.loop = false;
		this.m_cameraAudioSource.Play();
		yield return new WaitForSeconds(2.5f);
		this.m_CamelScript.goToCharacter();
		yield return new WaitForSeconds(1.0f);
		this.m_cameraAudioSource.clip = this.m_magic;
		this.m_cameraAudioSource.loop = false;
		this.m_cameraAudioSource.Play();
		yield return new WaitForSeconds(0.5f);
		this.m_gameObject.animation.CrossFadeQueued("idle");
		yield return new WaitForSeconds(4.0f);
		this.m_gameObject.animation.wrapMode = WrapMode.Loop;
	}
	
	private IEnumerator startSmooking()
	{
		this.m_cameraAudioSource.Stop();
		this.m_gameObject.animation.wrapMode = WrapMode.Once;
		this.m_gameObject.animation.CrossFade("jump_on_the_package");
		this.m_gameObject.animation.CrossFadeQueued("end");
		this.m_mummyAudioSource.clip = this.m_jumpOn;
		this.m_mummyAudioSource.loop = false;
		this.m_mummyAudioSource.Play();
		yield return new WaitForSeconds(5.0f);
		this.m_sarcophageObject.animation.CrossFade("close");
		this.m_mummyAudioSource.clip = this.m_openSarcophage;
		this.m_mummyAudioSource.loop = false;
		this.m_mummyAudioSource.Play();
		yield return new WaitForSeconds(1.0f);

		this.m_gameObject.animation.Stop();
		this.m_gameObject.animation["stay"].speed = 0.0f;
		this.m_gameObject.animation.Play("stay", AnimationPlayMode.Stop);
		this.m_gameObject.animation.Rewind();
		this.m_gameObject.animation.wrapMode = WrapMode.Once;
		
		this.m_gameObject.transform.position = this.initPosition;
		this.m_gameObject.transform.rotation = this.initRotation;
		
		this.m_cameraAudioSource.clip = this.m_StartSmooke;
		this.m_cameraAudioSource.loop = false;
		this.m_cameraAudioSource.Play();
		
		yield return new WaitForSeconds(1.0f);
		this.m_LeftSmokePS.enableEmission = true;
		this.m_RightSmokePS.enableEmission = true;
		yield return new WaitForSeconds(2.0f);
		this.showGUI = true;

		this.m_cameraAudioSource.clip = this.m_smoke;
		this.m_cameraAudioSource.loop = true;
		this.m_cameraAudioSource.Play();
	}
	
	public void drink()
	{
		StartCoroutine(startDrink());
	}
			
	private IEnumerator startDrink()
	{
		this.m_gameObject.animation.wrapMode = WrapMode.Once;
		this.m_gameObject.animation.CrossFade("take_the_jar");
		this.m_gameObject.animation.CrossFadeQueued("drink");
		this.m_gameObject.animation.CrossFadeQueued("take_off_the_jar");
		this.m_gameObject.animation.CrossFadeQueued("idle");
		yield return new WaitForSeconds(0.9f);
		this.m_VaseOriginalPosition = this.m_Vase.transform.localPosition;
		this.m_VaseOriginalRotation = this.m_Vase.transform.localRotation;
		this.m_Vase.parent = this.m_MummyHand;
		yield return new WaitForSeconds(1.0f);
		this.m_cameraAudioSource.clip = this.m_drinking;
		this.m_cameraAudioSource.loop = false;
		this.m_cameraAudioSource.Play();
		yield return new WaitForSeconds(4.3f);
		this.m_Vase.parent = this.m_VaseOriginalParent;
		this.m_Vase.transform.localPosition = this.m_VaseOriginalPosition;
		this.m_Vase.transform.localRotation = this.m_VaseOriginalRotation;
		yield return new WaitForSeconds(1.0f);
		this.m_CamelScript.goHome();
		yield return new WaitForSeconds(2.0f);
		this.m_gameObject.animation.wrapMode = WrapMode.Loop;
		yield return new WaitForSeconds(3.0f);
		this.m_gameObject.animation.CrossFade("dance");
		this.m_cameraAudioSource.clip = this.m_dance;
		this.m_cameraAudioSource.loop = true;
		this.m_cameraAudioSource.Play();
		this.showGUI = true;
	}
	
	public override void SmokeOn()
	{
		this.showGUI = false;
		this.startSmookAnimation();
	}
	
	public override void SmokeOff()
	{
		this.showGUI = false;
		this.startOnAnimation();
	}
	
	public override bool ShowGUI()
	{
		return this.showGUI;
	}
	
	public override void lose()
	{
		this.m_mummyAudioSource.Stop();
		this.m_cameraAudioSource.Stop();
	}
	
	public override void restart()
	{
		this.firstStart = true;
		this.m_gameObject.transform.parent = this.oldParent;
		this.m_gameObject.transform.position = this.initPosition;
		this.m_gameObject.transform.rotation = this.initRotation;
	
		this.m_mummyAudioSource.Stop();
		this.m_cameraAudioSource.Stop();
		
		this.m_LeftSmokePS.enableEmission = false;
		this.m_RightSmokePS.enableEmission = false;
	}
	
	void Update () {
	
	}
}
